/*       -*- C++ -*- */
/** \file
 ********************************************************************
 * $URL: svn+ssh://nalw02/home/alg/schlemme/svn/cextools/trunk/cex2pdf.cpp $
 * $Id: cex2pdf.cpp 13 2008-04-21 08:52:07Z schlemme $
 * $Date: 2008-04-21 10:52:07 +0200 (Mo, 21 Apr 2008) $
 * $Revision: 13 $
 * \author Tobias Schlemmer <keinstein@users.berlios.de>
 * $Author: schlemme $ 
 * \license LGPL
 * 
 * Main program. 
 *
 * \addtogroup main
 *
 *\{
 ********************************************************************
 */	  
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <string>
#include <libxml++/libxml++.h>
#include <map>
#include <set>
#include <iostream>
#include <cairomm/context.h>
#include <cairomm/surface.h>
#include "cexfile.h"
#include "svddraw.h"
#include "pdfplot.h"

/// main program
/** loads a .cex file and plots it. 
 \todo Command line parsing
 \param argc Number of command line arguments
 \param argv array of command line arguments
 */
int main(int argc, char * argv[]) {
	std::string filename,basename,ext;
	std::string::size_type p;
	
	if (argc != 2) {
		std::cerr << "Usage: " << *argv << " filename.cex" << std:: endl;
		return 1;
	}
	else filename = std::string(argv[1]);
	
	if (filename.substr(p=filename.length()-4,4) == ".cex") 
		basename=filename.substr(0,p);
	else {
		basename = filename;
	}
	
	cexfile::cexfile* file;
	try {
		
		file = new cexfile::cexfile(filename);
	} catch(const std::exception& ex) {
		std::cout << "Exception caught: " << ex.what() << std::endl;
		abort();
	}
	
#ifdef DEBUG
	std::cerr << *file;
#endif
	
	SVDDraw (file);
	
	pdfplot * plotter = new pdfplot(file,basename);
	plotter->plot();
	delete plotter;
	
	return 0;
}

// \}
