/*       -*- C++ -*- */
/** \file
 ********************************************************************
 * $URL: svn+ssh://nalw02/home/alg/schlemme/svn/cextools/trunk/include/cexfile/constants.h $
 * $Id: constants.h 12 2008-02-26 15:45:35Z schlemme $
 * $Date: 2008-02-26 16:45:35 +0100 (Di, 26 Feb 2008) $
 * $Revision: 12 $
 * \author Tobias Schlemmer <keinstein@users.berlios.de>
 * $Author: schlemme $ 
 * \license LGPL
 * 
 * XML file string constants.
 ********************************************************************
 */	  
#ifndef CEXFILE_CONSTANTS_H
#define CEXFILE_CONSTANTS_H

namespace cexfile {
  /** \name XML file string constants.
      These constants describe node,
      attribute and value names used in .cex XML files.
      \{
  */
  const Glib::ustring  DOC_XML_ROOT = "ConceptualSystem";
  const Glib::ustring  CONTEXTS_COLLECTION = "Contexts";

  const Glib::ustring  CONTEXT_ELEMENT = "Context";
  const Glib::ustring  CONTEXT_ELEMENT_TYPE_ATTRIBUTE = "Type";
  const Glib::ustring  CONTEXT_TYPE_BINARY = "Binary";

  const Glib::ustring  LATTICE_COLLECTION = "Lattices";
  const Glib::ustring  LATTICE_ELEMENT = "Lattice";
  const Glib::ustring  ATTRIBUTE_MASK_ELEMENT = "AttributeMask";
  const Glib::ustring  OBJECT_MASK_ELEMENT = "ObjectMask";

  const Glib::ustring  LATTICE_DIAGRAM = "LineDiagram";
  const Glib::ustring  LATTICE_DIAGRAM_SETTINGS = "LineDiagramSettings";
  const Glib::ustring  ATTRIBUTE_LABEL_DISPLAY_MODE = 
    "AttributeLabelsDisplayMode";
  const Glib::ustring  OBJECT_LABEL_STRATEGY_DISPLAY_MODE =
    "ObjectLabelsDisplayMode";
  const Glib::ustring  LABEL_FONT_SIZE = "LabelFontSize";
  const Glib::ustring  SHOW_COLLISIONS = "ShowCollisions";
  const Glib::ustring  MAX_NODE_RADIUS = "MaxNodeRadius";
  const Glib::ustring  NODE_RADIUS_MODE = "NodeRadiusMode";
  const Glib::ustring  EDGE_DISPLAY_MODE = "EdgeDisplayMode";
  const Glib::ustring  HIGHLIGHT_MODE = "HighlightMode";
  const Glib::ustring  GRID_SIZE_X = "GridSizeX";
  const Glib::ustring  GRID_SIZE_Y = "GridSizeY";
  const Glib::ustring  SELECTION = "Selection";
  const Glib::ustring  LATTICE_LAYOUT = "Layout";

  const Glib::ustring  VALUE_ATTRIBUTE = "Value";
  const Glib::ustring  CONCEPT_FIGURES_ELEMENT = "ConceptFigures";
  const Glib::ustring  ATTRIBUTE_LABELS_ELEMENT = "AttributeLabels";
  const Glib::ustring  OBJECT_LABELS_ELEMENT = "ObjectLabels";
  const Glib::ustring  CONCEPT_LABELS_ELEMENT = "ConceptLabels";
  //In order to preserbe backward compatibility
  const Glib::ustring  DOWN_CONCEPT_LABELS_ELEMENT = CONCEPT_LABELS_ELEMENT;
  const Glib::ustring  UP_CONCEPT_LABELS_ELEMENT = "UpConceptLabels";


  const Glib::ustring  FIGURE = "LineDiagramFigure";
  const Glib::ustring  FIGURE_TYPE_ATTRIBUTE = "Type";
  const Glib::ustring  ATTRIBUTE_LABEL_FIGURE_TYPE = "AttributeLabel";
  const Glib::ustring  OBJECT_LABEL_FIGURE_TYPE = "ObjectLabel";
  const Glib::ustring  CONCEPT_FIGURE_TYPE = "Concept";
  const Glib::ustring  CONCEPT_LABEL_FIGURE_TYPE = "ConceptLabel";


  const Glib::ustring  FIGURE_COORDS = "FigureCooords";
  const Glib::ustring  POINT2D = "Point2D";
  const Glib::ustring  POINT2D_X = "x";
  const Glib::ustring  POINT2D_Y = "y";

  const Glib::ustring  ATTRIBUTE_COLLECTION = "Attributes";
  const Glib::ustring  ATTRIBUTE_ELEMENT = "Attribute";
  const Glib::ustring  ATTRIBUTE_REFERENCE = "AttributeReference";

  const Glib::ustring  OBJECT_COLLECTION = "Objects";
  const Glib::ustring  OBJECT_ELEMENT = "Object";
  const Glib::ustring  OBJECT_REFERENCE = "ObjectReference";

  const Glib::ustring  INTENT = "Intent";

  const Glib::ustring  OBJECT_HAS_ATTRIBUTE = "HasAttribute";
  const Glib::ustring  ATTRIBUTE_ID = "AttributeIdentifier";

  const Glib::ustring  ELEMENT_NAME_ELEMENT = "Name";
  const Glib::ustring  ID_ATTRIBUTE = "Identifier";

  const Glib::ustring  VERSION_ELEMENT = "Version";
  const Glib::ustring  VERSION_MAJOR_NUMBER_ATTRIBUTE = "MajorNumber";
  const Glib::ustring  VERSION_MINOR_NUMBER_ATTRIBUTE = "MinorNumber";

  const Glib::ustring  RECALCULATION_POLICY = "RecalculationPolicy"; 
  
  // strategies
  
  const Glib::ustring  NO_ATTRIBS_LABELING_STRATEGY =
    "NoAttribsLabelsStrategy";
  const Glib::ustring  ALL_ATTRIBS_LABELING_STRATEGY_KEY = 
    "AllAttribsLabelsStrategy";
  const Glib::ustring  ATTRIBS_MULTI_LABELING_STRATEGY_KEY =
    "AllAttribsMultiLabelsStrategy";
  const Glib::ustring  OWN_ATTRIBS_COUNT_LABELING_STRATEGY
  = "OwnAttribsCountLabelsStrategy";

  const Glib::ustring  NO_OBJECTS_LABELING_STRATEGY = 
    "NoObjectsLabelsStrategy";
  const Glib::ustring  ALL_OBJECTS_LABELING_STRATEGY =
    "AllObjectsLabelsStrategy";
  const Glib::ustring  OWN_OBJECTS_COUNT_LABELING_STRATEGY =
    "OwnObjectsCountLabelsStrategy";
  const Glib::ustring  OBJECTS_MULTI_LABELING_STRATEGY_KEY =
    "AllObjectsMultiLabelsStrategy";

  const Glib::ustring  OBJECTS_COUNT_LABELING_STRATEGY = 
    "ObjectsCountLabelsStrategy";
  const Glib::ustring  STABILITY_TO_DESCTRUCTION_LABELING_STRATEGY =
    "StabilityLabelsStrategy";

  const Glib::ustring  POINT_STABILITY_LABELING_STRATEGY =
    "PointStabilityLabelsStrategy";
  const Glib::ustring  INTEGRAL_STABILITY_LABELING_STRATEGY = 
    "IntegralStabilityLabelsStrategy";
  // \}

}

#endif /* CEXFILE_CONSTANTS_H */
